#ifndef NODES_H
#define NODES_H

#include "set.h"

struct nodegroup {
    char *fmt;           /* The format of the node name */
    struct set *nodes;   /* The set of nodes which fill the format */
};

struct nodelist {
    struct nodegroup *list;
    int reduced;
    size_t size, maxsize, idx;
};

extern struct nodelist *nodelist_parse(char *list);
extern void nodelist_destroy(struct nodelist *nl);
extern void nodelist_reset(struct nodelist *nl);
extern char *nodelist_next(struct nodelist *nl, char *buf, size_t bufsize);
extern char *nodelist_next_cmpt(struct nodelist *nl, char *buf, size_t bufsize);
extern int nodelist_reduce(struct nodelist *nl);
extern struct nodelist *nodelist_parse_file(char *fn);
extern int nodes_init(int argc, char *argv[], int min_size,
                      char **filename, int *size, int *all, int *optind);
extern int nodelist_insert_node(struct nodelist *nl, char *nodename);
extern int nodelist_exists(struct nodelist *nl, char *nodename);
#endif /* NODES_H */
