#ifndef PTFPS_OPTIONS_H
#define PTFPS_OPTIONS_H

#include <stdio.h>
#include "ptfps_expr.h"

typedef int (*parser_t)(char *[], void **);
typedef int (*evaluator_t)(expression_t *, process_t *, char *, size_t);

#define OPT_VARARGS     -1
#define OPT_VAEND       ";"

typedef struct option {
	char * name;
    char * desc;
	int numargs;
    enum {OPT_TEST, OPT_ACTION} opttype;

    parser_t parse;
	evaluator_t eval;
} option_t;
extern option_t options[];
extern int num_options;
extern int optcmp(const void *a, const void *b);

extern void opt_init();
extern void opt_print_usage(FILE *f);

#endif /* PTFPS_OPTIONS_H */
